(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('@angular/common'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('ngtreegrid', ['exports', '@angular/core', 'rxjs', '@angular/common', '@angular/forms'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.ngtreegrid = {}, global.ng.core, global.rxjs, global.ng.common, global.ng.forms));
}(this, (function (exports, i0, rxjs, common, forms) { 'use strict';

    var NgtreegridService = /** @class */ (function () {
        function NgtreegridService() {
            this.display_data_observable = new rxjs.Subject();
            this.display_data_observable$ = this.display_data_observable.asObservable();
        }
        NgtreegridService.prototype.updateDisplayDataObservable = function (display_data) {
            this.display_data_observable.next(display_data);
        };
        NgtreegridService.prototype.isEmpty = function (value) {
            return value === '' || value === undefined || value === 'undefined';
        };
        NgtreegridService.prototype.expandAll = function (expand_tracker) {
            for (var key in expand_tracker) {
                if (expand_tracker.hasOwnProperty(key)) {
                    expand_tracker[key] = true;
                }
            }
        };
        NgtreegridService.prototype.collapseAll = function (expand_tracker) {
            for (var key in expand_tracker) {
                if (expand_tracker.hasOwnProperty(key)) {
                    expand_tracker[key] = false;
                }
            }
            expand_tracker['data'] = true;
        };
        return NgtreegridService;
    }());
    NgtreegridService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgtreegridService_Factory() { return new NgtreegridService(); }, token: NgtreegridService, providedIn: "root" });
    NgtreegridService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    NgtreegridService.ctorParameters = function () { return []; };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var Store = /** @class */ (function () {
        function Store(ngTreeGridService) {
            this.ngTreeGridService = ngTreeGridService;
            this.processed_data = [];
            this.raw_data = [];
            this.group_keys = {}; // Contains all group keys.
            this.processed_tree_data = {}; // Contains all group keys.
        }
        Store.prototype.getRawData = function () {
            return this.raw_data;
        };
        Store.prototype.setRawData = function (raw_data) {
            this.raw_data = raw_data;
        };
        Store.prototype.getProcessedData = function (processed_data) {
            return this.processed_data;
        };
        Store.prototype.setProcessedData = function (processed_data) {
            this.processed_data = processed_data;
            this.setDisplayData(__spread(processed_data));
        };
        Store.prototype.getDisplayData = function () {
            return this.display_data;
        };
        Store.prototype.setDisplayData = function (display_data) {
            this.display_data = display_data;
            this.ngTreeGridService.updateDisplayDataObservable(this.display_data);
        };
        Store.prototype.filterBy = function (fields, search_values) {
            var _this = this;
            this.display_data = this.processed_data.filter(function (record) {
                if (record.parent) {
                    return true;
                }
                var found = true;
                for (var index = 0; index < fields.length; index++) {
                    var field_value = record[fields[index]];
                    var search_value = search_values[index];
                    // If blank then continue.
                    if (!search_value) {
                        continue;
                    }
                    if (typeof (field_value) === 'number') {
                        if (field_value !== parseInt(search_value, 10)) {
                            found = false;
                        }
                    }
                    else {
                        var column = _this.configs.columns[index];
                        if (!column.case_sensitive_filter) {
                            field_value = field_value.toLowerCase();
                            search_value = search_value.toLowerCase();
                        }
                        if (field_value.indexOf(search_value) === -1) {
                            found = false;
                        }
                    }
                }
                return found;
            });
            this.ngTreeGridService.updateDisplayDataObservable(this.display_data);
        };
        Store.prototype.selectAll = function () {
            this.display_data.forEach(function (data) {
                data.row_selected = true;
            });
        };
        Store.prototype.deSelectAll = function () {
            this.display_data.forEach(function (data) {
                data.row_selected = false;
            });
        };
        /**
    * Find path from root and assgn grouped data
    *
    * @param temp_traversed_paths It is the traversed path for the current group by key.
    * @param index Current index of the leaf node
    * @param group_by_data Generated group by data for the current leaf node
    */
        Store.prototype.traverseRootData = function (temp_traversed_paths, index, group_by_data) {
            var paths = temp_traversed_paths[index].split('.');
            var root_keys = this.processed_tree_data;
            for (var i = 0; i < paths.length - 1; i++) {
                var path = paths[i];
                root_keys = root_keys[path];
            }
            // Set in last object to keep the reference.
            root_keys[paths[paths.length - 1]] = group_by_data;
        };
        Store.prototype.groupData = function (data, configs, internal_configs, edit_tracker, expand_tracker) {
            var _this = this;
            var group_by = configs.group_by;
            // It is an array of leaf nodes.
            var last_group_data = [data];
            // It represents the path to the leaf nodes.
            var traversed_paths = ['data'];
            this.processed_tree_data = { 'data': '' };
            group_by.forEach(function (key) {
                var temp_traversed_paths = [];
                var temp_last_group_data = [];
                var group_keys = [];
                var _loop_1 = function (index) {
                    var group_data = last_group_data[index];
                    var group_by_data = _this.groupByKey(group_data, key);
                    _this.traverseRootData(traversed_paths, index, group_by_data);
                    var new_group_keys = Object.keys(group_by_data);
                    var traversed_group_key = traversed_paths[index];
                    // Get list of grouped data for the current group by in an array.
                    new_group_keys.forEach(function (new_group_key) {
                        // Make keys separated by dots for all group by. Example 'data.book.type'
                        temp_traversed_paths.push(traversed_group_key + '.' + new_group_key);
                        temp_last_group_data.push(group_by_data[new_group_key]);
                    });
                    group_keys.push.apply(group_keys, __spread(new_group_keys));
                };
                // Number of records in traversed_paths and last_group_data are same.
                for (var index = 0; index < last_group_data.length; index++) {
                    _loop_1(index);
                }
                traversed_paths = temp_traversed_paths;
                last_group_data = temp_last_group_data;
                // Remove duplicates and blanks.
                group_keys = group_keys.filter(function (item, pos) {
                    return !_this.ngTreeGridService.isEmpty(item) && group_keys.indexOf(item) === pos;
                });
                _this.group_keys[key] = group_keys;
            });
            if (internal_configs.current_sorted_column) {
                this.processData(internal_configs.current_sorted_column.sort_type, internal_configs.current_sorted_column.name, edit_tracker, expand_tracker);
            }
            else {
                this.processData(null, null, edit_tracker, expand_tracker);
            }
            this.setRawData(data);
            this.configs = configs;
        };
        Store.prototype.groupByKey = function (data, group_by) {
            var group_by_data = {};
            // Make an array of group by key.
            data.forEach(function (item) {
                // Check if group by key is already an array or not.
                if (!group_by_data[item[group_by]]) {
                    group_by_data[item[group_by]] = [];
                }
                group_by_data[item[group_by]].push(item);
            });
            return group_by_data;
        };
        Store.prototype.processData = function (sort_type, sort_by, edit_tracker, expand_tracker) {
            this.processed_data = [];
            var index = 0;
            // Make recursive call to generate records.
            this.generateData(sort_type, sort_by, this.processed_tree_data, 0, null, expand_tracker);
            this.processed_data.shift();
            // Add index to all records.
            this.processed_data.forEach(function (data) {
                data.idx = index++;
                edit_tracker[data.idx] = false;
            });
            // Expand root so that first level shows up.
            expand_tracker['data'] = 1;
            this.setProcessedData(this.processed_data);
        };
        Store.prototype.generateData = function (sort_type, sort_by, group_data, level, parent_key, expand_tracker) {
            var _this = this;
            var group_keys = Object.keys(group_data);
            group_keys.forEach(function (key) {
                var items = group_data[key];
                var composite_key = parent_key ? parent_key + '.' + key : key;
                // If items is not an array then it has more group by arrays. So make recursive call.
                if (!Array.isArray(items)) {
                    // Create an array of children ids.
                    var children = Object.keys(items);
                    var children_id_1 = [];
                    children.forEach(function (child) {
                        // Add child id to the composite key.
                        children_id_1.push(composite_key + '.' + child);
                    });
                    _this.processed_data.push({
                        parent_id: parent_key,
                        node_id: composite_key,
                        node_text: key,
                        parent: true,
                        last_parent: false,
                        children: children_id_1,
                        level: level
                    });
                    expand_tracker[composite_key] = 0;
                    // Increase level to mark the level.
                    _this.generateData(sort_type, sort_by, items, level + 1, composite_key, expand_tracker);
                }
                else {
                    // Set Parent object.
                    _this.processed_data.push({
                        parent_id: parent_key,
                        node_id: composite_key,
                        node_text: key,
                        parent: true,
                        last_parent: true,
                        level: level
                    });
                    expand_tracker[composite_key] = 0;
                    // Sort Items
                    if (sort_type !== null) {
                        sort_type ? items.sort(function (a, b) { return (a[sort_by] > b[sort_by]) ? 1 : ((b[sort_by] > a[sort_by]) ? -1 : 0); }) :
                            items.sort(function (a, b) { return (a[sort_by] < b[sort_by]) ? 1 : ((b[sort_by] < a[sort_by]) ? -1 : 0); });
                    }
                    // Set Child object.
                    items.forEach(function (item) {
                        item.parent = false;
                        item.parent_id = composite_key;
                        _this.processed_data.push(item);
                    });
                }
            });
        };
        Store.prototype.refreshDisplayData = function () {
            this.display_data = this.processed_data;
            this.ngTreeGridService.updateDisplayDataObservable(this.display_data);
        };
        return Store;
    }());

    var NgtreegridComponent = /** @class */ (function () {
        function NgtreegridComponent(ngtreegridService) {
            this.ngtreegridService = ngtreegridService;
            this.expand_tracker = {}; // Track Expand or collapse.
            this.columns = []; // Contains all column objects.
            this.edit_tracker = {}; // Track Edit options.
            this.internal_configs = {
                show_add_row: false
            };
            this.default_configs = {
                css: {
                    expand_class: 'plus',
                    collapse_class: 'minus',
                    add_class: 'plus',
                    edit_class: '',
                    delete_class: '',
                    save_class: '',
                    cancel_class: '',
                    row_selection_class: 'selected',
                    header_class: '',
                    parent_class: 'parent',
                    row_filter_class: ''
                },
                actions: {
                    edit: false,
                    add: false,
                    delete: false,
                    resolve_edit: false,
                    resolve_add: false,
                    resolve_delete: false
                },
                data_loading_text: 'Loading...',
                group_by: [],
                group_by_header: [],
                action_column_width: '50px',
                filter: false,
                multi_select: false,
                group_by_width: [],
                multi_select_width: 'auto',
                row_class_function: function () { return true; },
                row_edit_function: function () { return true; },
                row_delete_function: function () { return true; },
                row_select_function: function () { return true; }
            };
            this.default_column_config = {
                sorted: 0,
                sort_type: null,
                editable: false,
                hidden: false,
                filter: true,
                case_sensitive_filter: false,
                sortable: true
            };
            this.store = new Store(this.ngtreegridService);
            this.expand = new i0.EventEmitter();
            this.collapse = new i0.EventEmitter();
            this.cellclick = new i0.EventEmitter();
            this.rowselect = new i0.EventEmitter();
            this.rowdeselect = new i0.EventEmitter();
            this.rowselectall = new i0.EventEmitter();
            this.rowdeselectall = new i0.EventEmitter();
            this.rowadd = new i0.EventEmitter();
            this.rowsave = new i0.EventEmitter();
            this.rowdelete = new i0.EventEmitter();
        }
        NgtreegridComponent.prototype.ngOnChanges = function () {
            this.setDefaultConfigs();
            this.setColumnNames();
            // If there is no data then do nothing.
            if (!(this.data && this.data.length > 0)) {
                window.console.warn('Data should not be empty!');
                return;
            }
            this.store.groupData(this.data, this.configs, this.internal_configs, this.edit_tracker, this.expand_tracker);
        };
        NgtreegridComponent.prototype.setDefaultConfigs = function () {
            this.store.processed_data = [];
            this.store.processed_tree_data = {};
            this.configs = Object.assign({}, this.default_configs, this.configs);
            // Deep clone.
            this.configs.actions = Object.assign({}, this.default_configs.actions, this.configs.actions);
            this.configs.css = Object.assign({}, this.default_configs.css, this.configs.css);
            if (!this.configs.group_by) {
                window.console.error('group_by field is mandatory!');
            }
            else if (!Array.isArray(this.configs.group_by)) {
                this.configs.group_by = [this.configs.group_by];
            }
            // Set default header for group_by field.
            if (!this.configs.group_by_header) {
                this.configs.group_by_header = this.configs.group_by;
            }
            else {
                if (!Array.isArray(this.configs.group_by_header)) {
                    this.configs.group_by_header = [this.configs.group_by_header];
                }
                if (this.configs.group_by_header.length !== this.configs.group_by.length) {
                    this.configs.group_by_header = this.configs.group_by;
                }
            }
            // Set default width for group_by field.
            if (!this.configs.group_by_width) {
                this.configs.group_by_width = this.configs.group_by.map(function (_) { return 'auto'; });
            }
            else {
                if (!Array.isArray(this.configs.group_by_width)) {
                    this.configs.group_by_width = [this.configs.group_by_width];
                }
                if (this.configs.group_by_width.length !== this.configs.group_by.length) {
                    this.configs.group_by_width = this.configs.group_by.map(function (_) { return 'auto'; });
                }
            }
        };
        NgtreegridComponent.prototype.setColumnNames = function () {
            var _this = this;
            this.columns = this.configs.columns ? this.configs.columns : [];
            // If columns doesn't exist in user's object.
            if (!this.configs.columns) {
                var column_keys_1 = Object.keys(this.data[0]);
                // Remove group by key.
                this.configs.group_by.forEach(function (key) {
                    column_keys_1.splice(column_keys_1.indexOf(key), 1);
                });
                // Insert Header and default configuration.
                column_keys_1.forEach(function (key) {
                    _this.columns.push(Object.assign({ 'header': key, 'name': key }, _this.default_column_config));
                });
            }
            else {
                // Insert Header and default configuration.
                for (var i = 0; i < this.columns.length; i++) {
                    this.columns[i] = Object.assign({}, this.default_column_config, this.columns[i]);
                }
            }
            if (!this.configs.group_by_column) {
                this.configs.group_by_column = Object.assign({}, this.default_column_config);
            }
        };
        NgtreegridComponent.prototype.onExpandRow = function (row) {
            this.expand.emit(row);
        };
        NgtreegridComponent.prototype.onCollapseRow = function (rec) {
            this.collapse.emit(rec);
        };
        NgtreegridComponent.prototype.onRowSelect = function (row) {
            this.rowselect.emit(row);
        };
        NgtreegridComponent.prototype.sortColumn = function (column) {
            if (!column.sortable) {
                return;
            }
            // If already sorted then reverse.
            column.sort_type = column.sorted ? !column.sort_type : 1;
            column.sorted = 1;
            this.internal_configs.current_sorted_column = column;
            // Sort array.
            this.store.processData(column.sort_type, column.name, this.edit_tracker, this.expand_tracker);
        };
        NgtreegridComponent.prototype.addRowToGrid = function () {
            this.store.processed_tree_data = {};
            this.edit_tracker = {};
            this.store.groupData(this.data, this.configs, this.internal_configs, this.edit_tracker, this.expand_tracker);
        };
        NgtreegridComponent.prototype.onRowAdd = function (rec) {
            var _this = this;
            if (this.configs.actions.resolve_delete) {
                var promise = new Promise(function (resolve, reject) {
                    _this.rowadd.emit({
                        data: rec,
                        resolve: resolve
                    });
                });
                promise.then(function () {
                    _this.addRowToGrid();
                }).catch(function (err) { });
            }
            else {
                this.addRowToGrid();
                this.rowadd.emit(rec);
            }
        };
        NgtreegridComponent.prototype.expandAll = function () {
            this.ngtreegridService.expandAll(this.expand_tracker);
        };
        NgtreegridComponent.prototype.collapseAll = function () {
            this.ngtreegridService.collapseAll(this.expand_tracker);
        };
        NgtreegridComponent.prototype.selectAll = function () {
            this.store.selectAll();
            this.internal_configs.all_selected = true;
        };
        NgtreegridComponent.prototype.deSelectAll = function () {
            this.store.deSelectAll();
            this.internal_configs.all_selected = false;
        };
        return NgtreegridComponent;
    }());
    NgtreegridComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'db-ngtreegrid',
                    template: "<table class=\"db-tree-grid\">\n    <thead db-tree-head\n      [columns]=\"columns\" \n      [configs]=\"configs\" \n      [internal_configs]=\"internal_configs\"\n      [store]=\"store\"\n      [rowselectall]=\"rowselectall\"\n      [rowdeselectall]=\"rowdeselectall\"\n      (sortcolumn)=\"sortColumn($event)\">\n    </thead>\n    \n    <tbody db-tree-body\n      [columns]=\"columns\" \n      [configs]=\"configs\" \n      [internal_configs]=\"internal_configs\"\n      [store]=\"store\"\n      [expand_tracker]=\"expand_tracker\" \n      [edit_tracker]=\"edit_tracker\"\n      [rowsave]=\"rowsave\"\n      [rowdelete]=\"rowdelete\"\n      [cellclick]=\"cellclick\"\n      (rowselect)=\"onRowSelect($event)\"\n      [rowdeselect]=\"rowdeselect\"\n      (rowexpand)=\"onExpandRow($event)\"\n      (rowcollapse)=\"onCollapseRow($event)\"\n      (rowadd)=\"onRowAdd($event)\">\n    </tbody>   \n    \n  </table>\n  ",
                    styles: [".db-tree-grid{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid grey;color:#4b4b4b}"]
                },] }
    ];
    NgtreegridComponent.ctorParameters = function () { return [
        { type: NgtreegridService }
    ]; };
    NgtreegridComponent.propDecorators = {
        expand: [{ type: i0.Output }],
        collapse: [{ type: i0.Output }],
        cellclick: [{ type: i0.Output }],
        rowselect: [{ type: i0.Output }],
        rowdeselect: [{ type: i0.Output }],
        rowselectall: [{ type: i0.Output }],
        rowdeselectall: [{ type: i0.Output }],
        rowadd: [{ type: i0.Output }],
        rowsave: [{ type: i0.Output }],
        rowdelete: [{ type: i0.Output }],
        data: [{ type: i0.Input }],
        configs: [{ type: i0.Input }]
    };

    var TreeBodyComponent = /** @class */ (function () {
        function TreeBodyComponent() {
            this.loadingColspanCount = 0;
            this.rowadd = new i0.EventEmitter();
            this.rowexpand = new i0.EventEmitter();
            this.rowcollapse = new i0.EventEmitter();
            this.rowselect = new i0.EventEmitter();
        }
        TreeBodyComponent.prototype.ngOnInit = function () {
            this.loadingColspanCount = this.columns.length + 1;
            if (this.configs.multi_select) {
                this.loadingColspanCount++;
            }
            if (this.configs.actions.edit || this.configs.actions.add || this.configs.actions.delete) {
                this.loadingColspanCount++;
            }
        };
        TreeBodyComponent.prototype.fetchTraversedPaths = function (traversed_paths) {
            var paths = traversed_paths.split('.');
            var intermediate = this.store.processed_tree_data;
            for (var i = 0; i < paths.length; i++) {
                var path = paths[i];
                intermediate = intermediate[path];
            }
            return intermediate;
        };
        TreeBodyComponent.prototype.expandRow = function (id, row) {
            var _this = this;
            this.expand_tracker[id] = 1;
            // If children is a parent and its value is empty then expand it automatically.
            row.children && row.children.forEach(function (child) {
                var ids = child.split('.');
                var last_child = ids[ids.length - 1];
                // If empty!
                if (_this.isEmpty(last_child)) {
                    _this.expand_tracker[child] = 1;
                }
            });
            this.rowexpand.emit(row);
        };
        TreeBodyComponent.prototype.collapseRow = function (id, rec) {
            var _this = this;
            this.expand_tracker[id] = 0;
            // Collapse all of its children.
            var keys = Object.keys(this.expand_tracker);
            keys.forEach(function (key) {
                if (key.indexOf(id) !== -1) {
                    _this.expand_tracker[key] = 0;
                }
            });
            this.rowcollapse.emit(rec);
        };
        TreeBodyComponent.prototype.isEmpty = function (value) {
            return value === '' || value === undefined || value === 'undefined';
        };
        TreeBodyComponent.prototype.range = function (end) {
            var array = [];
            var current = 1;
            while (current < end) {
                array.push(current);
                current += 1;
            }
            return array;
        };
        TreeBodyComponent.prototype.rowAdd = function (row) {
            this.rowadd.emit(row);
        };
        TreeBodyComponent.prototype.saveRecord = function ($event) {
            var _this = this;
            var rec = $event.data;
            if (this.configs.actions.resolve_edit) {
                var promise = new Promise(function (resolve, reject) {
                    _this.rowsave.emit({
                        data: rec,
                        resolve: resolve
                    });
                });
                promise.then(function () {
                    _this.edit_tracker[rec['idx']] = false;
                }).catch(function (err) { });
            }
            else {
                this.edit_tracker[rec['idx']] = false;
                this.rowsave.emit(rec);
            }
        };
        TreeBodyComponent.prototype.cancelEdit = function (row_data) {
            var index = row_data['idx'];
            this.edit_tracker[index] = false;
            // Cancel all changes ie copy from back up.
            Object.assign(row_data, this.internal_configs.current_edited_row);
        };
        TreeBodyComponent.prototype.prepareRowClass = function (data) {
            var row_class = { 'child': !data.parent };
            row_class[this.configs.css.parent_class] = data.parent;
            row_class[this.configs.css.row_selection_class] = data.row_selected;
            return row_class;
        };
        TreeBodyComponent.prototype.selectRow = function (row_data, event) {
            // Don't run if Multi select is enabled.
            if (this.configs.multi_select) {
                return;
            }
            if (row_data.parent) {
                return;
            }
            this.store.processed_data.forEach(function (data) {
                data.row_selected = false;
            });
            row_data.row_selected = true;
            this.rowselect.emit({ data: row_data, event: event });
        };
        TreeBodyComponent.prototype.selectRowOnCheck = function (row_data, event) {
            if (!row_data.row_selected) {
                row_data.row_selected = true;
                this.rowselect.emit({ data: row_data, event: event });
            }
            else {
                row_data.row_selected = false;
                this.rowdeselect.emit({ data: row_data, event: event });
            }
            this.setSelectAllConfig();
        };
        /**
         * Set Select All config on Select change.
         *
         */
        TreeBodyComponent.prototype.setSelectAllConfig = function () {
            var select_all = true;
            this.store.getDisplayData().forEach(function (data) {
                if (!data.row_selected) {
                    select_all = false;
                }
            });
            this.internal_configs.all_selected = select_all;
        };
        TreeBodyComponent.prototype.showSelectBox = function (row_data) {
            if (this.configs.row_select_function) {
                return this.configs.row_select_function(row_data);
            }
            else {
                return true;
            }
        };
        return TreeBodyComponent;
    }());
    TreeBodyComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: '[db-tree-body]',
                    template: "\n<tr *ngIf=\"store.raw_data.length==0\">\n  <td [innerHTML]=\"configs.data_loading_text\" [attr.colspan]=\"loadingColspanCount\" style=\"text-align: center\"></td>\n</tr>\n<tr db-filter-row \n  [columns]=\"columns\" \n  [configs]=\"configs\"\n  [store]=\"store\"\n  [internal_configs]=\"internal_configs\" \n  *ngIf=\"configs.filter\"\n  [expand_tracker]=\"expand_tracker\"\n  [ngClass]=\"configs.css.row_filter_class\">\n</tr>\n<tr db-add-row \n  [columns]=\"columns\" \n  [configs]=\"configs\" \n  [internal_configs]=\"internal_configs\" \n  [store]=\"store\"\n  (rowadd)=\"rowAdd($event)\"\n  *ngIf=\"internal_configs.show_add_row\">\n</tr>\n\n<tr \n  *ngFor=\"let data of store.display_data\"\n  [ngClass]=\"prepareRowClass(data)\" \n  [attr.id]=\"data['idx']\" \n  (click)=\"selectRow(data, $event)\" \n  class=\"{{configs.row_class_function(data)}}\">\n\n  <!-- If parent text is empty then hide -->\n  <ng-container *ngIf=\"expand_tracker[data.parent_id] && data.parent && !isEmpty(data.node_text)\">\n    <td *ngIf=\"configs.multi_select\" class=\"checkbox_column\">\n      <!-- <input type=\"checkbox\" [checked]=\"data.row_selected\" (click)=\"selectRowOnCheck(data, $event)\"> -->\n    </td>\n    <td *ngIf=\"(configs.actions.edit || configs.actions.add || configs.actions.delete)\"></td>\n    <!-- Leave left td for down level parents -->\n    <td *ngFor=\"let level of range(data.level)\" class=\"clear-right-border clear-left-border\"></td>\n    <td *ngIf=\"!expand_tracker[data.node_id]\"   \n        [ngClass]=\"{\n          'clear-right-border': true, \n          'clear-left-border': (configs.actions.edit || configs.actions.add || configs.actions.delete)\n        }\">\n        <table class=\"expand-column-table\">\n          <tr>\n            <td>\n              <span (click)=\"expandRow(data.node_id, data)\" class=\"expand-icon-container\" title=\"Expand row\">\n                <i class=\"{{this.configs.css.expand_class}}\" aria-hidden=\"true\"></i>\n              </span>\n            </td>\n            <td>\n              <div class=\"parent-container\">\n                <db-tree-cell \n                [cell_value]=\"data.node_text\" \n                [row_data]=\"data\"\n                [column]=\"configs.group_by_column\">\n              </db-tree-cell>\n            </div>\n            </td>\n          </tr>\n        </table>\n    </td>\n    <td *ngIf=\"expand_tracker[data.node_id]\"  \n        [ngClass]=\"{\n          'clear-right-border': true, \n          'clear-left-border': (configs.actions.edit || configs.actions.add || configs.actions.delete)\n        }\"\n        >\n        <table class=\"expand-column-table\">\n          <tr>\n            <td>\n              <span (click)=\"collapseRow(data.node_id, data)\" class=\"expand-icon-container\" title=\"Collapse row\">\n                <i class=\"{{this.configs.css.collapse_class}}\" aria-hidden=\"true\"></i>\n              </span>\n            </td>\n            <td>\n              <div class=\"parent-container\">\n                <db-tree-cell \n                  [cell_value]=\"data.node_text\" \n                  [row_data]=\"data\"\n                  [column]=\"configs.group_by_column\">\n                </db-tree-cell>\n              </div>\n            </td>\n          </tr>\n        </table>\n    </td>\n    <!-- For parent levels add extra tds -->\n    <td \n      *ngFor=\"let level of range(configs.group_by.length - data.level + 1)\" \n      class=\"clear-right-border clear-left-border\">\n    </td>\n    <td *ngFor=\"let column of columns\" [ngClass]=\"{'column-hide': column.hidden}\">\n      <ng-container *ngIf=\"column.group_aggregator && data.last_parent\">\n        <span [innerHTML]=\"column.group_aggregator(fetchTraversedPaths(data.node_id))\"></span>\n      </ng-container>\n      <ng-container *ngIf=\"column.group_component && data.last_parent\">\n        <db-tree-cell \n          [cell_value]=\"data\" \n          [row_data]=\"fetchTraversedPaths(data.node_id)\" \n          [column]=\"column.group_component\">\n        </db-tree-cell>\n      </ng-container>\n    </td>\n  </ng-container>\n  <ng-container *ngIf=\"expand_tracker[data.parent_id] && !data.parent\">\n    <td *ngIf=\"configs.multi_select\" class=\"checkbox_column\" (click)=\"selectRowOnCheck(data, $event)\">\n      <input type=\"checkbox\" [checked]=\"data.row_selected\" *ngIf=\"showSelectBox(data)\">\n    </td>\n    <td db-tree-cell-actions \n      *ngIf=\"configs.actions.edit || configs.actions.delete || configs.actions.add\" \n      [data]=\"data\"\n      [configs]=\"configs\"\n      [store]=\"store\"\n      [edit_tracker]=\"edit_tracker\"\n      [rowdelete]=\"rowdelete\"\n      [internal_configs]=\"internal_configs\"\n      (canceledit)=\"cancelEdit($event)\" \n      (editcomplete)=\"saveRecord($event)\">\n    </td>\n    <td \n      [ngClass]=\"{\n        'clear-right-border': true, \n        'clear-left-border': (configs.actions.edit || configs.actions.add || configs.actions.delete)\n      }\" \n      *ngFor=\"let header of configs.group_by\">\n    </td>\n    <td class=\"clear-left-border\" *ngFor=\"let column of columns\" [ngClass]=\"{'column-hide': column.hidden}\">\n      <db-tree-cell \n        [cell_value]=\"data[column.name]\" \n        [row_data]=\"data\" \n        [column]=\"column\" \n        [cellclick]=\"cellclick\"\n        [edit_on]=\"edit_tracker[data['idx']]\"\n        (canceledit)=\"cancelEdit($event)\"\n        (editcomplete)=\"saveRecord($event)\">\n      </db-tree-cell>            \n    </td>\n  </ng-container>\n  \n</tr>\n",
                    styles: [".db-tree-grid{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid grey;color:#4b4b4b}select{padding:5px}tr.child{background:#fff}tr.parent{background:#fafbff}tr.selected{background-color:#e2e7eb}tr span.expand-icon-container{padding-right:10px;cursor:pointer}tr div.parent-container{display:inline-block}tr i.minus{border:1px solid transparent;margin-right:23px}tr i.minus:before{content:\"\";width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:10px;margin-left:6px}tr td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem}tr td.checkbox_column{text-align:center}tr td:first-child{padding:.3rem}tr td i.plus{border:1px solid transparent;margin-right:23px}tr td i.plus:before{width:18px;height:1px;border-top:2px solid #222;margin-top:10px;margin-left:6px}tr td i.plus:after,tr td i.plus:before{content:\"\";display:block;position:absolute}tr td i.plus:after{width:1px;height:18px;border-right:2px solid #222;margin-top:2px;margin-left:14px}td.clear-left-border{border-left:0!important}td.clear-right-border{border-right:0!important}.column-hide{display:none}.expand-column-table td{border:none;padding:0!important}"]
                },] }
    ];
    TreeBodyComponent.ctorParameters = function () { return []; };
    TreeBodyComponent.propDecorators = {
        store: [{ type: i0.Input }],
        expand_tracker: [{ type: i0.Input }],
        edit_tracker: [{ type: i0.Input }],
        columns: [{ type: i0.Input }],
        configs: [{ type: i0.Input }],
        internal_configs: [{ type: i0.Input }],
        rowdelete: [{ type: i0.Input }],
        rowsave: [{ type: i0.Input }],
        rowdeselect: [{ type: i0.Input }],
        cellclick: [{ type: i0.Input }],
        rowadd: [{ type: i0.Output }],
        rowexpand: [{ type: i0.Output }],
        rowcollapse: [{ type: i0.Output }],
        rowselect: [{ type: i0.Output }]
    };

    var TreeCellViewComponent = /** @class */ (function () {
        function TreeCellViewComponent() {
            this.cellclick = new i0.EventEmitter();
        }
        TreeCellViewComponent.prototype.ngOnInit = function () {
        };
        return TreeCellViewComponent;
    }());
    TreeCellViewComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'db-tree-cell-view',
                    template: "<div (click)=\"cellclick.emit($event)\">{{column.renderer ? column.renderer(cell_value, row_data) : cell_value}}</div>",
                    styles: [""]
                },] }
    ];
    TreeCellViewComponent.ctorParameters = function () { return []; };
    TreeCellViewComponent.propDecorators = {
        cell_value: [{ type: i0.Input }],
        row_data: [{ type: i0.Input }],
        column: [{ type: i0.Input }],
        cellclick: [{ type: i0.Output }]
    };

    var CustomCellViewComponent = /** @class */ (function () {
        function CustomCellViewComponent(resolver) {
            this.resolver = resolver;
        }
        CustomCellViewComponent.prototype.ngOnInit = function () {
            if (this.column.component && !this.custom_component) {
                this.createCustomComponent();
                this.callOnComponentInit();
            }
        };
        CustomCellViewComponent.prototype.ngOnDestroy = function () {
            if (this.custom_component) {
                this.custom_component.destroy();
            }
        };
        CustomCellViewComponent.prototype.createCustomComponent = function () {
            var componentFactory = this.resolver.resolveComponentFactory(this.column.component);
            this.custom_component = this.custom_view.createComponent(componentFactory);
        };
        CustomCellViewComponent.prototype.callOnComponentInit = function () {
            this.column.on_component_init && this.column.on_component_init(this.custom_component.instance);
            this.custom_component.instance.cell_value = this.cell_value;
            this.custom_component.instance.row_data = this.row_data;
        };
        return CustomCellViewComponent;
    }());
    CustomCellViewComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'db-custom-cell-component',
                    template: "\n      <ng-template #customView></ng-template>\n    "
                },] }
    ];
    CustomCellViewComponent.ctorParameters = function () { return [
        { type: i0.ComponentFactoryResolver }
    ]; };
    CustomCellViewComponent.propDecorators = {
        column: [{ type: i0.Input }],
        cell_value: [{ type: i0.Input }],
        row_data: [{ type: i0.Input }],
        custom_view: [{ type: i0.ViewChild, args: ['customView', { read: i0.ViewContainerRef, static: true },] }]
    };

    var DefaultEditor = /** @class */ (function () {
        function DefaultEditor() {
            this.canceledit = new i0.EventEmitter();
            this.editcomplete = new i0.EventEmitter();
            this.cellclick = new i0.EventEmitter();
        }
        return DefaultEditor;
    }());
    DefaultEditor.decorators = [
        { type: i0.Component, args: [{
                    selector: '',
                    template: ''
                },] }
    ];
    DefaultEditor.propDecorators = {
        canceledit: [{ type: i0.Output }],
        editcomplete: [{ type: i0.Output }],
        cellclick: [{ type: i0.Output }]
    };

    var CustomCellEditorComponent = /** @class */ (function (_super) {
        __extends(CustomCellEditorComponent, _super);
        function CustomCellEditorComponent(resolver) {
            var _this = _super.call(this) || this;
            _this.resolver = resolver;
            return _this;
        }
        CustomCellEditorComponent.prototype.ngOnInit = function () {
            if (this.column.editor && !this.custom_component) {
                this.createCustomComponent();
                this.callOnComponentInit();
            }
        };
        CustomCellEditorComponent.prototype.ngOnDestroy = function () {
            if (this.custom_component) {
                this.custom_component.destroy();
            }
        };
        CustomCellEditorComponent.prototype.createCustomComponent = function () {
            var componentFactory = this.resolver.resolveComponentFactory(this.column.editor);
            this.custom_component = this.custom_view.createComponent(componentFactory);
        };
        CustomCellEditorComponent.prototype.callOnComponentInit = function () {
            var _this = this;
            this.column.on_component_init && this.column.on_component_init(this.custom_component.instance);
            this.custom_component.instance.cell_value = this.cell_value;
            this.custom_component.instance.row_data = this.row_data;
            this.custom_component.instance.column = this.column;
            this.custom_component.instance.editcomplete.subscribe(function (event) { return _this.editcomplete.emit(event); });
            this.custom_component.instance.canceledit.subscribe(function (event) { return _this.canceledit.emit(event); });
            this.custom_component.instance.cellclick.subscribe(function (event) { return _this.cellclick.emit(event); });
        };
        return CustomCellEditorComponent;
    }(DefaultEditor));
    CustomCellEditorComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'db-custom-cell-editor-component',
                    template: "\n      <ng-template #customView></ng-template>\n    "
                },] }
    ];
    CustomCellEditorComponent.ctorParameters = function () { return [
        { type: i0.ComponentFactoryResolver }
    ]; };
    CustomCellEditorComponent.propDecorators = {
        column: [{ type: i0.Input }],
        cell_value: [{ type: i0.Input }],
        row_data: [{ type: i0.Input }],
        custom_view: [{ type: i0.ViewChild, args: ['customView', { read: i0.ViewContainerRef, static: true },] }]
    };

    var TreeCellEditorComponent = /** @class */ (function (_super) {
        __extends(TreeCellEditorComponent, _super);
        function TreeCellEditorComponent() {
            return _super.call(this) || this;
        }
        TreeCellEditorComponent.prototype.ngOnInit = function () {
        };
        return TreeCellEditorComponent;
    }(DefaultEditor));
    TreeCellEditorComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'db-tree-cell-editor',
                    template: "<input type=\"text\" \n    [(ngModel)]=\"row_data[column.name]\" \n    class=\"cell-default\" \n    (click)=\"cellclick.emit($event)\"\n    (keydown.enter)=\"editcomplete.emit($event)\"\n    (keydown.esc)=\"canceledit.emit()\"\n    >",
                    styles: ["input.cell-default{padding:5px}"]
                },] }
    ];
    TreeCellEditorComponent.ctorParameters = function () { return []; };
    TreeCellEditorComponent.propDecorators = {
        cell_value: [{ type: i0.Input }],
        row_data: [{ type: i0.Input }],
        column: [{ type: i0.Input }]
    };

    var TreeCellActionsComponent = /** @class */ (function () {
        function TreeCellActionsComponent() {
            this.editcomplete = new i0.EventEmitter();
            this.canceledit = new i0.EventEmitter();
        }
        TreeCellActionsComponent.prototype.ngOnInit = function () {
        };
        TreeCellActionsComponent.prototype.enableEdit = function (row_data) {
            var index = row_data['idx'];
            this.edit_tracker[index] = true;
            this.internal_configs.current_edited_row = Object.assign({}, row_data);
        };
        TreeCellActionsComponent.prototype.findRecordIndex = function (idx) {
            for (var index = 0; index < this.store.processed_data.length; index++) {
                if (this.store.processed_data[index].idx === idx) {
                    return index;
                }
            }
        };
        TreeCellActionsComponent.prototype.deleteRecord = function (rec) {
            var _this = this;
            if (this.configs.actions.resolve_delete) {
                var promise = new Promise(function (resolve, reject) {
                    _this.rowdelete.emit({
                        data: rec,
                        resolve: resolve
                    });
                });
                promise.then(function () {
                    _this.store.processed_data.splice(_this.findRecordIndex(rec.idx), 1);
                    _this.store.refreshDisplayData();
                }).catch(function (err) { });
            }
            else {
                this.store.processed_data.splice(this.findRecordIndex(rec.idx), 1);
                this.store.refreshDisplayData();
                this.rowdelete.emit(rec);
            }
        };
        TreeCellActionsComponent.prototype.saveRecord = function ($event) {
            this.editcomplete.emit({ event: $event, data: this.data });
        };
        return TreeCellActionsComponent;
    }());
    TreeCellActionsComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: '[db-tree-cell-actions]',
                    template: "<ng-container *ngIf=\"configs.actions.edit && configs.row_edit_function(data)\">\n  <div *ngIf=\"!edit_tracker[data['idx']]\" class=\"icon-container\">\n    <i (click)=\"enableEdit(data)\" *ngIf=\"configs.css.edit_class\" title=\"Edit row\" class=\"{{this.configs.css.edit_class}}\" aria-hidden=\"true\" ></i>\n    <svg (click)=\"enableEdit(data)\" *ngIf=\"!configs.css.edit_class\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Edit row</title><g data-name=\"Layer 2\"><g data-name=\"edit\"><rect width=\"24\" height=\"24\" opacity=\"0\"/><path d=\"M19.4 7.34L16.66 4.6A2 2 0 0 0 14 4.53l-9 9a2 2 0 0 0-.57 1.21L4 18.91a1 1 0 0 0 .29.8A1 1 0 0 0 5 20h.09l4.17-.38a2 2 0 0 0 1.21-.57l9-9a1.92 1.92 0 0 0-.07-2.71zM9.08 17.62l-3 .28.27-3L12 9.32l2.7 2.7zM16 10.68L13.32 8l1.95-2L18 8.73z\"/></g></g></svg>             \n  </div>\n  <ng-container *ngIf=\"edit_tracker[data['idx']]\">\n    <div class=\"icon-container\">\n      <i (click)=\"saveRecord($event)\" *ngIf=\"configs.css.save_class\" title=\"Save row\" class=\"{{this.configs.css.save_class}}\" aria-hidden=\"true\"></i>\n      <svg (click)=\"saveRecord($event)\" title=\"Save row\" *ngIf=\"!configs.css.save_class\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Save row</title><g data-name=\"Layer 2\"><g data-name=\"save\"><rect width=\"24\" height=\"24\" opacity=\"0\"/><path d=\"M20.12 8.71l-4.83-4.83A3 3 0 0 0 13.17 3H6a3 3 0 0 0-3 3v12a3 3 0 0 0 3 3h12a3 3 0 0 0 3-3v-7.17a3 3 0 0 0-.88-2.12zM10 19v-2h4v2zm9-1a1 1 0 0 1-1 1h-2v-3a1 1 0 0 0-1-1H9a1 1 0 0 0-1 1v3H6a1 1 0 0 1-1-1V6a1 1 0 0 1 1-1h2v5a1 1 0 0 0 1 1h4a1 1 0 0 0 0-2h-3V5h3.17a1.05 1.05 0 0 1 .71.29l4.83 4.83a1 1 0 0 1 .29.71z\"/></g></g></svg>\n    </div>\n    <div class=\"icon-container\">\n      <i (click)=\"canceledit.emit(data)\" *ngIf=\"configs.css.cancel_class\" title=\"Cancel row\" class=\"{{this.configs.css.cancel_class}}\" aria-hidden=\"true\"></i>\n      <svg (click)=\"canceledit.emit(data)\" *ngIf=\"!configs.css.cancel_class\" title=\"Cancel row\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Cancel row</title><g data-name=\"Layer 2\"><g data-name=\"close\"><rect width=\"24\" height=\"24\" transform=\"rotate(180 12 12)\" opacity=\"0\"/><path d=\"M13.41 12l4.3-4.29a1 1 0 1 0-1.42-1.42L12 10.59l-4.29-4.3a1 1 0 0 0-1.42 1.42l4.3 4.29-4.3 4.29a1 1 0 0 0 0 1.42 1 1 0 0 0 1.42 0l4.29-4.3 4.29 4.3a1 1 0 0 0 1.42 0 1 1 0 0 0 0-1.42z\"/></g></g></svg>\n    </div>\n  </ng-container>\n</ng-container>            \n<div *ngIf=\"configs.actions.delete && !edit_tracker[data['idx']] && configs.row_delete_function(data)\" class=\"icon-container\">\n  <i *ngIf=\"configs.css.delete_class\" title=\"Delete row\" (click)=\"deleteRecord(data)\" class=\"{{this.configs.css.delete_class}}\" aria-hidden=\"true\"></i>\n  <svg *ngIf=\"!configs.css.delete_class\" title=\"Delete row\" (click)=\"deleteRecord(data)\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Delete row</title><g data-name=\"Layer 2\"><g data-name=\"trash-2\"><rect width=\"24\" height=\"24\" opacity=\"0\"/><path d=\"M21 6h-5V4.33A2.42 2.42 0 0 0 13.5 2h-3A2.42 2.42 0 0 0 8 4.33V6H3a1 1 0 0 0 0 2h1v11a3 3 0 0 0 3 3h10a3 3 0 0 0 3-3V8h1a1 1 0 0 0 0-2zM10 4.33c0-.16.21-.33.5-.33h3c.29 0 .5.17.5.33V6h-4zM18 19a1 1 0 0 1-1 1H7a1 1 0 0 1-1-1V8h12z\"/><path d=\"M9 17a1 1 0 0 0 1-1v-4a1 1 0 0 0-2 0v4a1 1 0 0 0 1 1z\"/><path d=\"M15 17a1 1 0 0 0 1-1v-4a1 1 0 0 0-2 0v4a1 1 0 0 0 1 1z\"/></g></g></svg>            \n</div>",
                    styles: ["svg{width:25px;padding-right:4px}div.icon-container{display:inline-block;width:50%;text-align:center;color:#000;cursor:pointer}"]
                },] }
    ];
    TreeCellActionsComponent.ctorParameters = function () { return []; };
    TreeCellActionsComponent.propDecorators = {
        store: [{ type: i0.Input }],
        edit_tracker: [{ type: i0.Input }],
        configs: [{ type: i0.Input }],
        rowdelete: [{ type: i0.Input }],
        data: [{ type: i0.Input }],
        internal_configs: [{ type: i0.Input }],
        editcomplete: [{ type: i0.Output }],
        canceledit: [{ type: i0.Output }]
    };

    var TreeCellComponent = /** @class */ (function () {
        function TreeCellComponent() {
            this.canceledit = new i0.EventEmitter();
            this.editcomplete = new i0.EventEmitter();
        }
        TreeCellComponent.prototype.ngOnInit = function () {
        };
        TreeCellComponent.prototype.onCellClick = function (rec, column) {
            this.cellclick.emit({ row: rec, column: column });
        };
        TreeCellComponent.prototype.onEditComplete = function ($event) {
            this.editcomplete.emit({ event: $event, data: this.row_data });
        };
        return TreeCellComponent;
    }());
    TreeCellComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'db-tree-cell',
                    template: "<ng-container>\n    <div [ngSwitch]=\"column.type\" *ngIf=\"!edit_on || !column.editable\">\n        <db-custom-cell-component \n            *ngSwitchCase=\"'custom'\" \n            [cell_value]=\"cell_value\" \n            [column]=\"column\" \n            [row_data]=\"row_data\" \n            (click)=\"onCellClick(row_data, column)\">\n        </db-custom-cell-component>\n        <db-tree-cell-view \n            *ngSwitchDefault \n            (cellclick)=\"onCellClick(row_data, column)\"\n            [cell_value]=\"cell_value\" \n            [column]=\"column\" \n            [row_data]=\"row_data\">\n        </db-tree-cell-view>\n    </div>\n    <div *ngIf=\"edit_on && column.editable\">\n        <db-custom-cell-editor-component \n            *ngIf=\"column.editor\" \n            [cell_value]=\"cell_value\" \n            [column]=\"column\" \n            [row_data]=\"row_data\"\n            (canceledit)=\"canceledit.emit(row_data['idx'])\"\n            (editcomplete)=\"onEditComplete($event)\">\n        </db-custom-cell-editor-component>\n        <db-tree-cell-editor \n            *ngIf=\"!column.editor\"\n            [cell_value]=\"cell_value\" \n            [row_data]=\"row_data\" \n            [column]=\"column\"\n            (canceledit)=\"canceledit.emit(row_data['idx'])\"\n            (editcomplete)=\"onEditComplete($event)\"\n            >\n        </db-tree-cell-editor>\n    </div>\n</ng-container>\n"
                },] }
    ];
    TreeCellComponent.ctorParameters = function () { return []; };
    TreeCellComponent.propDecorators = {
        cell_value: [{ type: i0.Input }],
        row_data: [{ type: i0.Input }],
        column: [{ type: i0.Input }],
        edit_on: [{ type: i0.Input }],
        cellclick: [{ type: i0.Input }],
        canceledit: [{ type: i0.Output }],
        editcomplete: [{ type: i0.Output }]
    };

    var CellModule = /** @class */ (function () {
        function CellModule() {
        }
        return CellModule;
    }());
    CellModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [
                        TreeCellComponent,
                        TreeCellViewComponent,
                        CustomCellViewComponent,
                        CustomCellEditorComponent,
                        TreeCellEditorComponent,
                        TreeCellActionsComponent
                    ],
                    imports: [
                        common.CommonModule,
                        forms.FormsModule
                    ],
                    exports: [
                        TreeCellComponent,
                        CustomCellViewComponent,
                        CustomCellEditorComponent,
                        TreeCellEditorComponent,
                        TreeCellActionsComponent
                    ]
                },] }
    ];

    var AddRowComponent = /** @class */ (function () {
        function AddRowComponent() {
            this.row_data = {};
            this.rowadd = new i0.EventEmitter();
            this.canceledit = new i0.EventEmitter();
        }
        AddRowComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.columns.forEach(function (column) {
                _this.row_data[column.name] = '';
            });
        };
        AddRowComponent.prototype.saveAddRecord = function (e) {
            var _this = this;
            // const add_column = {};
            var index = this.store.processed_data.length;
            // this.columns.forEach(column => {
            //   if (column.editable) {
            //     add_column[column.name] = (document.getElementById(index + column.name) as HTMLInputElement).value;
            //   } else {
            //     add_column[column.name] = '';
            //   }
            // });
            this.configs.group_by.forEach(function (key) {
                _this.row_data[key] = document.getElementById(index + key).value;
            });
            this.store.raw_data.push(this.row_data);
            this.internal_configs.show_add_row = false;
            this.rowadd.emit(this.row_data);
        };
        AddRowComponent.prototype.cancelAddEdit = function () {
            this.internal_configs.show_add_row = false;
        };
        return AddRowComponent;
    }());
    AddRowComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: '[db-add-row]',
                    template: "<td *ngIf=\"configs.multi_select\"></td>\n<td>\n  <div class=\"icon-container\">\n    <i (click)=\"saveAddRecord($event)\" *ngIf=\"configs.css.save_class\" title=\"Save row\" class=\"{{this.configs.css.save_class}}\" aria-hidden=\"true\"></i>\n    <svg (click)=\"saveAddRecord($event)\" title=\"Save row\" *ngIf=\"!configs.css.save_class\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Save row</title><g data-name=\"Layer 2\"><g data-name=\"save\"><rect width=\"24\" height=\"24\" opacity=\"0\"/><path d=\"M20.12 8.71l-4.83-4.83A3 3 0 0 0 13.17 3H6a3 3 0 0 0-3 3v12a3 3 0 0 0 3 3h12a3 3 0 0 0 3-3v-7.17a3 3 0 0 0-.88-2.12zM10 19v-2h4v2zm9-1a1 1 0 0 1-1 1h-2v-3a1 1 0 0 0-1-1H9a1 1 0 0 0-1 1v3H6a1 1 0 0 1-1-1V6a1 1 0 0 1 1-1h2v5a1 1 0 0 0 1 1h4a1 1 0 0 0 0-2h-3V5h3.17a1.05 1.05 0 0 1 .71.29l4.83 4.83a1 1 0 0 1 .29.71z\"/></g></g></svg>\n  </div>\n  <div class=\"icon-container\">\n    <i (click)=\"cancelAddEdit()\" *ngIf=\"configs.css.cancel_class\" title=\"Cancel row\" class=\"{{this.configs.css.cancel_class}}\" aria-hidden=\"true\"></i>\n    <svg (click)=\"cancelAddEdit()\" *ngIf=\"!configs.css.cancel_class\" title=\"Cancel row\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Cancel row</title><g data-name=\"Layer 2\"><g data-name=\"close\"><rect width=\"24\" height=\"24\" transform=\"rotate(180 12 12)\" opacity=\"0\"/><path d=\"M13.41 12l4.3-4.29a1 1 0 1 0-1.42-1.42L12 10.59l-4.29-4.3a1 1 0 0 0-1.42 1.42l4.3 4.29-4.3 4.29a1 1 0 0 0 0 1.42 1 1 0 0 0 1.42 0l4.29-4.3 4.29 4.3a1 1 0 0 0 1.42 0 1 1 0 0 0 0-1.42z\"/></g></g></svg>\n  </div>\n</td>\n<td *ngFor=\"let group_by of configs.group_by\">\n  <select [attr.id]=\"store.processed_data.length+group_by\">\n    <option *ngFor=\"let key of store.group_keys[group_by]\">\n    {{key}}\n    </option>\n  </select>\n</td>\n<td *ngFor=\"let column of columns\" [ngClass]=\"{'column-hide': column.hidden}\" >\n  <div *ngIf=\"column.editable\">\n    <db-custom-cell-editor-component \n        *ngIf=\"column.editor\"\n        [cell_value]=\"\" \n        [column]=\"column\" \n        [row_data]=\"row_data\"\n        (canceledit)=\"cancelAddEdit()\"\n        (editcomplete)=\"saveAddRecord($event)\">\n    </db-custom-cell-editor-component>\n    <db-tree-cell-editor \n        *ngIf=\"!column.editor\"\n        [cell_value]=\"\" \n        [row_data]=\"row_data\" \n        [column]=\"column\"\n        (canceledit)=\"cancelAddEdit()\"\n        (editcomplete)=\"saveAddRecord($event)\"\n        >\n    </db-tree-cell-editor>\n  </div>\n</td>",
                    encapsulation: i0.ViewEncapsulation.None,
                    styles: [".db-tree-grid{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid grey;color:#4b4b4b}select{padding:5px}tr.child{background:#fff}tr.parent{background:#fafbff}tr.selected{background-color:#e2e7eb}tr span.expand-icon-container{padding-right:10px;cursor:pointer}tr div.parent-container{display:inline-block}tr i.minus{border:1px solid transparent;margin-right:23px}tr i.minus:before{content:\"\";width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:10px;margin-left:6px}tr td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem}tr td.checkbox_column{text-align:center}tr td:first-child{padding:.3rem}tr td i.plus{border:1px solid transparent;margin-right:23px}tr td i.plus:before{width:18px;height:1px;border-top:2px solid #222;margin-top:10px;margin-left:6px}tr td i.plus:after,tr td i.plus:before{content:\"\";display:block;position:absolute}tr td i.plus:after{width:1px;height:18px;border-right:2px solid #222;margin-top:2px;margin-left:14px}td.clear-left-border{border-left:0!important}td.clear-right-border{border-right:0!important}.column-hide{display:none}.expand-column-table td{border:none;padding:0!important}svg{width:25px;padding-right:4px}div.icon-container{display:inline-block;width:50%;text-align:center;color:#000}"]
                },] }
    ];
    AddRowComponent.ctorParameters = function () { return []; };
    AddRowComponent.propDecorators = {
        store: [{ type: i0.Input }],
        columns: [{ type: i0.Input }],
        configs: [{ type: i0.Input }],
        internal_configs: [{ type: i0.Input }],
        rowadd: [{ type: i0.Output }],
        canceledit: [{ type: i0.Output }]
    };

    var FilterRowComponent = /** @class */ (function () {
        function FilterRowComponent(ngTreeGridService) {
            this.ngTreeGridService = ngTreeGridService;
            this.search_values = {};
        }
        FilterRowComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.columns.forEach(function (column) {
                _this.search_values[column.name] = '';
            });
        };
        FilterRowComponent.prototype.filter = function () {
            this.store.filterBy(this.columns.map(function (column) { return column.name; }), Object.values(this.search_values));
            this.ngTreeGridService.expandAll(this.expand_tracker);
        };
        return FilterRowComponent;
    }());
    FilterRowComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: '[db-filter-row]',
                    template: "<td *ngIf=\"configs.multi_select\"></td>\n<td *ngIf=\"(configs.actions.edit || configs.actions.delete || configs.actions.add)\"></td>\n<td *ngFor=\"let group_by of configs.group_by\"></td>\n<td *ngFor=\"let column of columns\">\n  <div *ngIf=\"column.filter\">\n    <input type=\"text\" (keyup)=\"filter()\" [(ngModel)]=\"search_values[column.name]\">\n  </div>\n</td>",
                    styles: [".db-tree-grid{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid grey;color:#4b4b4b}select{padding:5px}tr.child{background:#fff}tr.parent{background:#fafbff}tr.selected{background-color:#e2e7eb}tr span.expand-icon-container{padding-right:10px;cursor:pointer}tr div.parent-container{display:inline-block}tr i.minus{border:1px solid transparent;margin-right:23px}tr i.minus:before{content:\"\";width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:10px;margin-left:6px}tr td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem}tr td.checkbox_column{text-align:center}tr td:first-child{padding:.3rem}tr td i.plus{border:1px solid transparent;margin-right:23px}tr td i.plus:before{width:18px;height:1px;border-top:2px solid #222;margin-top:10px;margin-left:6px}tr td i.plus:after,tr td i.plus:before{content:\"\";display:block;position:absolute}tr td i.plus:after{width:1px;height:18px;border-right:2px solid #222;margin-top:2px;margin-left:14px}td.clear-left-border{border-left:0!important}td.clear-right-border{border-right:0!important}.column-hide{display:none}.expand-column-table td{border:none;padding:0!important}td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.2rem}td input{width:100%;padding:.1rem;box-sizing:border-box;-webkit-box-sizing:border-box;-moz-box-sizing:border-box}"]
                },] }
    ];
    FilterRowComponent.ctorParameters = function () { return [
        { type: NgtreegridService }
    ]; };
    FilterRowComponent.propDecorators = {
        store: [{ type: i0.Input }],
        columns: [{ type: i0.Input }],
        expand_tracker: [{ type: i0.Input }],
        configs: [{ type: i0.Input }],
        internal_configs: [{ type: i0.Input }]
    };

    var BodyModule = /** @class */ (function () {
        function BodyModule() {
        }
        return BodyModule;
    }());
    BodyModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [TreeBodyComponent, AddRowComponent, FilterRowComponent],
                    imports: [
                        common.CommonModule,
                        CellModule,
                        forms.FormsModule
                    ],
                    exports: [TreeBodyComponent, AddRowComponent]
                },] }
    ];

    var TreeHeadComponent = /** @class */ (function () {
        function TreeHeadComponent() {
            this.sortcolumn = new i0.EventEmitter();
        }
        TreeHeadComponent.prototype.ngOnInit = function () { };
        TreeHeadComponent.prototype.addRow = function () {
            this.internal_configs.show_add_row = true;
        };
        TreeHeadComponent.prototype.sortColumn = function (column) {
            this.sortcolumn.emit(column);
        };
        TreeHeadComponent.prototype.selectAll = function (e) {
            if (e.target.checked) {
                this.store.selectAll();
                this.rowselectall.emit(e);
            }
            else {
                this.store.deSelectAll();
                this.rowdeselectall.emit(e);
            }
        };
        return TreeHeadComponent;
    }());
    TreeHeadComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: '[db-tree-head]',
                    template: "<tr [ngClass]=\"configs.css.header_class\">\n  <th *ngIf=\"configs.multi_select\" class=\"checkbox_column\"  [attr.width]=\"configs.multi_select_width\">\n    <input type=\"checkbox\" (click)=\"selectAll($event)\" [checked]=\"this.internal_configs.all_selected\">\n  </th>\n  <th \n    *ngIf=\"configs.actions.add || configs.actions.edit || configs.actions.delete\" \n    class=\"action-column\"\n    width=\"{{configs.action_column_width}}\"\n    (click)=\"addRow()\">\n    <span class=\"icon-container\">\n      <i *ngIf=\"!internal_configs.show_add_row && configs.actions.add\" [ngClass]=\"configs.css.add_class\" aria-hidden=\"true\" title=\"Add a row\"></i>\n      <span *ngIf=\"internal_configs.show_add_row || !configs.actions.add\">Actions</span>\n    </span>\n  </th>\n  <th class=\"clear-right-border group-by-column\" [attr.width]=\"configs.group_by_width[i]\"\n      *ngFor=\"let header of configs.group_by_header; let i = index\">\n    {{header}}\n  </th>\n  <th *ngFor=\"let column of columns\" (click)=\"sortColumn(column)\" [attr.width]=\"column.width\"\n    [ngClass]=\"{'sorted': column.sorted,'sortable': column.sortable, 'column-hide': column.hidden}\" >\n      <span>{{column.header}}</span>\n      <span *ngIf=\"column.sortable\" [ngClass]=\"column.sorted && column.sort_type == 0?'arrow-down active':'arrow-down'\"></span>\n      <span *ngIf=\"column.sortable\" [ngClass]=\"column.sorted && column.sort_type == 1?'arrow-up active':'arrow-up'\"></span>\n  </th>\n</tr>",
                    styles: [".db-tree-grid{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid grey;color:#4b4b4b}tr{background:#fff}tr th{font-weight:600;line-height:1.25;color:#181818}tr th.action-column span.icon-container,tr th.sortable{cursor:pointer}tr th.sortable:hover span.arrow-up{border-bottom:6px solid #afafaf}tr th.sortable:hover span.arrow-down{border-top:6px solid #afafaf}tr th span.arrow-up{width:0;height:0;border-left:5px solid transparent;border-right:5px solid transparent;border-bottom:6px solid #ddd;position:relative;top:-18px;font-size:1rem}tr th span.arrow-up.active{border-bottom:6px solid #8a8989!important}tr th span.arrow-down{width:0;height:0;border-left:5px solid transparent;border-right:5px solid transparent;border-top:6px solid #ddd;position:relative;left:10px;top:17px;font-size:1rem}tr th span.arrow-down.active{border-top:6px solid #8a8989!important}tr th{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem}tr th:first-child{padding:.3rem}tr th i.plus{border:1px solid transparent}tr th i.plus:before{width:18px;height:1px;border-top:2px solid #222;margin-top:-15px;margin-left:6px}tr th i.plus:after,tr th i.plus:before{content:\"\";display:block;position:absolute}tr th i.plus:after{width:1px;height:18px;border-right:2px solid #222;margin-top:-23px;margin-left:14px}tr th.clear-left-border{border-left:0!important}tr th.clear-right-border{border-right:0!important}tr th.checkbox_column{text-align:center}.column-hide{display:none}svg{width:25px;padding-right:5px}"]
                },] }
    ];
    TreeHeadComponent.ctorParameters = function () { return []; };
    TreeHeadComponent.propDecorators = {
        store: [{ type: i0.Input }],
        columns: [{ type: i0.Input }],
        configs: [{ type: i0.Input }],
        internal_configs: [{ type: i0.Input }],
        sortcolumn: [{ type: i0.Output }],
        rowselectall: [{ type: i0.Input }],
        rowdeselectall: [{ type: i0.Input }]
    };

    var HeadModule = /** @class */ (function () {
        function HeadModule() {
        }
        return HeadModule;
    }());
    HeadModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [TreeHeadComponent],
                    imports: [
                        common.CommonModule
                    ],
                    exports: [TreeHeadComponent]
                },] }
    ];

    var NgtreegridModule = /** @class */ (function () {
        function NgtreegridModule() {
        }
        return NgtreegridModule;
    }());
    NgtreegridModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [NgtreegridComponent],
                    imports: [
                        common.CommonModule,
                        BodyModule,
                        HeadModule
                    ],
                    exports: [NgtreegridComponent]
                },] }
    ];

    /*
     * Public API Surface of ngtreegrid
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.DefaultEditor = DefaultEditor;
    exports.NgtreegridComponent = NgtreegridComponent;
    exports.NgtreegridModule = NgtreegridModule;
    exports.NgtreegridService = NgtreegridService;
    exports.ɵa = BodyModule;
    exports.ɵb = TreeBodyComponent;
    exports.ɵc = AddRowComponent;
    exports.ɵd = FilterRowComponent;
    exports.ɵe = CellModule;
    exports.ɵf = TreeCellComponent;
    exports.ɵg = TreeCellViewComponent;
    exports.ɵh = CustomCellViewComponent;
    exports.ɵi = CustomCellEditorComponent;
    exports.ɵj = TreeCellEditorComponent;
    exports.ɵk = TreeCellActionsComponent;
    exports.ɵl = HeadModule;
    exports.ɵm = TreeHeadComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngtreegrid.umd.js.map
